'''
libclamav - clamav python module
 
(c) 2008-2009 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
'''

import os
from ctypes import *
from ctypes.util import find_library
from const import *
from shared import ClamAVError

def clamav(solib=None, *args, **kw):
    if not solib:
      solib = find_library('clamav')
    if not solib:
      raise ClamAVError('ClamAV library not found!')
    libver = int(os.path.basename(solib).split('.')[2])
    if libver==6:
      import libso6 as libso
    elif libver==5:
      import libso5 as libso
    elif libver==4:
      import libso4 as libso
    elif libver==3:
      import libso3 as libso
    else:
      raise ClamAVError("Unsupported library: '%s'" % solib)
    so = cdll.LoadLibrary(solib)
    return libso.clamav(so, *args, **kw)
